/********************************************************************************
  output/mgavid.hh

  purpose:
    MGA_VID (Matrox G200/G400 BES output).

  notes:

  to do:

  author(s):
   - Dirk Farin, farin@ti.uni-mannheim.de

  modifications:
   13/Jun/2000 - Dirk Farin
    - first implementation

 ********************************************************************************
    Copyright (C) 1999  Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef DVDVIEW_OUTPUT_MGAVID_HH
#define DVDVIEW_OUTPUT_MGAVID_HH

#include "output/output.hh"
#include "ulib/graphics/basic/image.hh"
#include "thirdparty/mga_vid.h"

class VideoOutput_MGA : public VideoOutput_Class
{
public:
  VideoOutput_MGA();
  ~VideoOutput_MGA();

  bool MGA_Available() const { return fileh != -1; }
  
  void SetScaledSize(int w,int h) { width=w; height=h; scaled=true; }
  void ResetScaledSize() { scaled=false; }

  void Show_const(const Image_YUV<Pixel>& img);

private:
  int fileh;
  bool first;
  mga_vid_config_t config;
  uint_8* base;

  bool scaled;
  int width,height;
};

#endif
