/********************************************************************************
    Copyright (C) 1999  Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#include "video12/vidsyntax.hh"

const int PoolSize = 10;

static PictureData* pdpool[PoolSize];
static int pdpoolsize=0;


PictureData* PictureData::GetPictureData(int w,int h)
{
  if (pdpoolsize==0)
    {
      PictureData* picdata = new PictureData;

      if (w>0)
	picdata->m_codedimage.Create(w,h);

      return picdata;
    }
  else
    {
      pdpoolsize--;
      PictureData* picdata = pdpool[pdpoolsize];

      if (picdata->m_codedimage.AskWidth()  != w ||
	  picdata->m_codedimage.AskHeight() != h)
	{
	  if (w!=0)
	    picdata->m_codedimage.Create(w,h);
	}

      return picdata;
    }
}


void PictureData::FreePictureData(PictureData* p)
{
  if (pdpoolsize==PoolSize)
    ::delete p;
  else
    pdpool[pdpoolsize++] = p;
}




#include "ulib/containers/array2.cc"

template class Array2<Macroblock>;
